precision mediump float;
uniform vec4 brightColor;
uniform vec4 darkColor;
uniform vec4 outerColor;
uniform float phase;
uniform vec2 rotation;
uniform float alpha;
void main()
{
   float R = 1.0;
//   float x = 2.0 * (gl_PointCoord.s - 0.5);
//   float y = 2.0 * (gl_PointCoord.t - 0.5);

   float xrc = 2.0 * (gl_PointCoord.s - 0.5);
   float yrc = 2.0 * (gl_PointCoord.t - 0.5);
   float x = rotation[0] * xrc - rotation[1] * yrc;
   float y = rotation[1] * xrc + rotation[0] * yrc;

   float r = x * x + y * y;
   float R2 = R * R;

//   if (abs(x) + abs(y) > R) {  // diamond
   vec4 color;
   if (phase == 0.0) {
      if (r > R) { // circle
         discard;
      } else if (r > 0.9 * R) {
         color = outerColor;
      } else {
         color = brightColor;
      }
   } else {
      if (r > R) { // circle
         discard;
      } else if (r > 0.9 * R) {
         color = outerColor;
      } else {
         float a = sqrt(y * y - 1.0);
         if (-phase < 0.0) {
            float p = a * (-phase * 2.0 + 1.0);
            if (x < p) {
               color = brightColor;
            } else {
               color = darkColor;
            }
         } else if (-phase > 0.0) {
            float p = a * (-phase * 2.0 - 1.0);
            if (x < p) {
               color = darkColor;
            } else {
               color = brightColor;
            }
         } else {
            color = brightColor;
         }
      }
   }
   gl_FragColor = vec4(color[0], color[1], color[2], color[3] * alpha);
//   gl_FragColor = sunColor;
}