uniform mat4 uMVPMatrix;
attribute vec4 vPosition0;
attribute vec4 vPosition1;
attribute float time0;
attribute float time1;
uniform vec4 vOffset;
uniform float xOffset;
uniform float time;
uniform float pointSize;
uniform float drawLines;
vec4 offsetPosition;
varying float phi;
varying float delta;
varying float sDrawLines;
void main() {
    delta = time1 - time0;
    phi = (time - time0) / delta;

    sDrawLines = drawLines;

    if (drawLines > 0.0) {
        offsetPosition[0] = vPosition0[0] + xOffset;
        offsetPosition[1] = vPosition0[1];
        offsetPosition[2] = vPosition0[2];
        offsetPosition[3] = vPosition0[3];

    } else {
        offsetPosition[0] = (1.0 - phi) * vPosition0[0] + phi * vPosition1[0] + xOffset;
        offsetPosition[1] = (1.0 - phi) * vPosition0[1] + phi * vPosition1[1];
        offsetPosition[2] = (1.0 - phi) * vPosition0[2] + phi * vPosition1[2];
        offsetPosition[3] = (1.0 - phi) * vPosition0[3] + phi * vPosition1[3];
    }
	gl_PointSize = pointSize;
    gl_Position = uMVPMatrix * offsetPosition + vOffset;

}