precision mediump float;
uniform vec4 vColor;
uniform vec4 beadColor;
uniform float beadSize;
uniform float alpha;
uniform float streamTime;
uniform float wrapTime;
uniform float streamLifetime;
varying float vData;

float dT;
float streamAlpha;

void main() {
   dT = mod(streamTime - vData, wrapTime);
   if (dT < 0. || dT > streamLifetime) {
        streamAlpha = 0.;
   } else {
       streamAlpha = (streamLifetime - dT) / streamLifetime;
   }
   if (streamAlpha > beadSize) {
        gl_FragColor = vec4(beadColor[0], beadColor[1], beadColor[2], streamAlpha * alpha * beadColor[3]);
   } else {
       gl_FragColor = vec4(vColor[0], vColor[1], vColor[2], streamAlpha * alpha * vColor[3]);
   }
}